#include <stdio.h>
#define WAVE_HEADER_SIZE 48

int sync_ok=0;
int offset;
int stat[25];
char name[32],head[9];
FILE *in, *out;

main(int argc,char **argv)
{	
	unsigned start,end,i;
	printf("ReadTape 1.1\n");
	if (argc!=3) { printf("Usage: readtape file.wav outfile\n"); exit(1);}
	in=fopen(argv[1],"rb"); out=fopen(argv[2],"wb");
	if (in==NULL || out==NULL) { printf("Unable to open file\n"); exit(1);}
	init();

	synchronize();
	sync_ok=1;
	putc(0x16,out); putc(0x16,out); putc(0x16,out); putc(0x24,out);
	for(i=0,offset=4;i<9;i++) {
		head[8-i]=getbyte();
		putc(head[8-i],out);
		offset++;
	}
	while(name[i]=getbyte()) { putc(name[i++],out); offset++; }
	putc(0,out); offset++;
	printf("Loading %s\n",name);
	start=(head[2]&0xff)*256+(head[1]&0xff);
	end=(head[4]&0xff)*256+(head[3]&0xff);
	printf("Start : %x\t End : %x\n",start,end);
	for(i=start;i<=end;i++) { putc(getbyte(),out); offset++; }
/*
	for(;;) putc(getbyte(),out);
*/
	close(in); close(out);
	exit(0);
}

int max=0,min=255,up=0,thres=0,last=0;

init()
{
	int i,val;
	for(i=0;i<WAVE_HEADER_SIZE;i++) last=getc(in);
	for(i=0;i<40;i++) {
		val=getc(in);
		if (val>max) max=val;
		if (val<min) min=val;
		up=val>last;
		last=val;
	}
	thres=(min+max)/2;
	while(1) {
		val=getc(in);
		if (val<last && up) break;
		up=val>last;
		last=val;
	}
	up=0; 
}
		

getbit()
{
	unsigned int val,length1=0,length2=0;
	while(1) {
		val=getc(in);
		if (val==EOF) exit(0);
		if (val>max) max=val;
		if (val<last && up) { up=0; thres=(max+min)/2; min=255;}
		last=val;
		if (val>thres) length1++;
		else break;
	}
	if (length1<25) stat[length1]++;
	while(1) {
		val=getc(in);
		if (val==EOF) exit(0);
		if (val<min) min=val;
		if (val>last && !up) { up=1; thres=(max+min)/2; max=0; }
		last=val;
		if (val<thres) length2++;
		else break;
	}
	if (length2<25) stat[length2]++;
	return length1+length2<23;
}

getbyte()
{
	int decaleur=0,byte=0,i,bit,sum=0;
	getbit();
	while(getbit()==1);
	for(i=0;i<8;i++) decaleur=(decaleur<<1)|getbit();
	for(i=0;i<8;i++) {
		bit=decaleur&1;
		decaleur=decaleur>>1;
		byte=(byte<<1)|bit;
		sum+=bit;
	}
	if ((sum&1)==getbit() && sync_ok) printf("parity error at offset $%x\n",offset);
	return byte;
}

synchronize()
{
	int decaleur=0,val;
	printf("Searching synchro...\n");
	while(1) {
		while((decaleur&0xff) != 0x68) decaleur=(decaleur<<1)|getbit();
		if (getbyte()!=0x16) continue;
		if (getbyte()!=0x16) continue;
		if (getbyte()!=0x16) continue;
		do {
			val=getbyte();
		} while (val==0x16);
		if (val==0x24) break;
	}
}

